#include "gfx.h"


int lin_ticks(int d,float t,float t1,float t2,int x_len,int y_len)
{
/* 4300 */
float x,y,zz;
int xt,yt;
     for(zz = t;fabs(zz)<=fabs(t1);zz=zz+t2)
     {
        if( d == 1 ){ y = zz; x = xmin; }
        if( d == 2 ){ x = zz; y = ymin;  }
        if( d == 3 ){ y = zz; x = xmax;  }
        if( d == 4 ){ x = zz; y = ymax;  }
        if( d == 7 ){ x = zz; y = 0;     }
        if( d == 8 ){ y = zz; x = 0;     }

        xt=x_coord(x);
        yt=y_coord(y);

        put_ticks(d,xt,yt,x_len,y_len);   /* 4375 */
     }
}

int log_ticks(int d,float t1,float t2,float t3,int x_len,int y_len)
{
/* 4350 */
int zz,t,xt,yt,t4;
int xlen,ylen;
float z,x,y;

     t4=(int)t3;

     for( zz = (int)(log10(t1))-1;zz<=(int)(log10(t2))+1;zz++)
     {
         for( t = 0 ;t <= t4 - 2 ;t++)
         {
              z = pow(10,zz) * (1 + (t*10) / t4 );

              if( d == 1 ) { y = z; x = xmin;}
              if( d == 2 ) { x = z; y = ymin;}
              if( d == 3 ) { y = z; x = xmax;}
              if( d == 4 ) { x = z; y = ymax;}
              if( d == 7 ) { x = z; y = 0 ;}
              if( d == 8 ) { y = z; x = 0 ;}


              xt=x_coord(x);
              yt=y_coord(y);

              xlen=x_len;
              ylen=y_len;

              if( (ticks == 'T' || ticks == 't') && t == 0) /* longer ticks on powers of 10 */
              {
                   xlen = (3 * x_len)/2;
                   ylen = (3 * y_len)/2;
              }
/* old yu yb defs (was acutally wrong before )
              if((d == 1 || d == 3 || d == 8) && yt > yu && yt < yb) put_ticks(d,xt,yt,xlen,ylen);
*/
              if((d == 1 || d == 3 || d == 8) && yt > (int)yb && yt < (int)yu) put_ticks(d,xt,yt,xlen,ylen);

              if((d == 2 || d == 4 || d == 7) && xt > (int)xl && xt < (int)xr) put_ticks(d,xt,yt,xlen,ylen);

         }
     }
}

put_ticks(int d,int x,int y,int x_len,int y_len)
{
int x0,y0,t5,t6;
static int dd;

     if( d == 1 ) { x0 = x + x_len; y0 = y; }
     if( d == 2 ) { x0 = x; y0 = y + y_len; }
     if( d == 3 ) { x0 = x - x_len; y0 = y;}
     if( d == 4 ) { x0 = x; y0 = y - y_len;}
     if( d == 7 ) { x0 = x; y0 = y - y_len / 2;  y = y + y_len / 2;}
     if( d == 8 ) { x0 = x - x_len / 2; x = x + x_len / 2;  y0 = y;}

     if(ticks != 't' && ticks != 't')  /* alternate drawing direction on grids (for hp plotter) */
     {
          if( dd == 1)
          {
                 t5 == x; t6 == y;  x == x0;  y == y0;
                 x0 == t5;  y0 == t6;  dd = 0 ;
          }
          else dd = 1;
     }
     xy[1] = x0; xy[2] = y0;  xy[3] = x;  xy[4] = y;
     dline(2);
     penup();

}


rescale(int flag)
{

float xx1,yy1,xx2,yy2;
char temp[20];

maxmin(&xx1,&xx2,&yy1,&yy2);

if(flag == 1)   /* if we don't have any previous values */
{
        xmax=xx2;
        xmin=xx1;
        ymax=yy2;
        ymin=yy1;
        s1=0;
        s2=0;
        strcpy(xlabel,"x axis");
        strcpy(ylabel,"y axis");
        ticks= 'n';
        xtick = 1.0;
        ytick = 1.0;
}

        rescale_form();

}

maxmin(float *xx1, float *xx2, float *yy1, float *yy2)
{
int i;

*xx2=-1.e6;
*xx1 = 1.e6;
*yy2=-1.e6;
*yy1 = 1.e6;

if(np <= 0 ) return -1;

for(i=1;i<=np;i++)
{
        if(xp[i] > *xx2) *xx2 = xp[i];
        if(yp[i] > *yy2) *yy2 = yp[i];
        if(xp[i] < *xx1) *xx1 = xp[i];
        if(yp[i] < *yy1) *yy1 = yp[i];

}

if(*xx2 == *xx1 ) *xx1 = *xx2 -1.;
if(*yy2 == *yy1 ) *yy1 = *yy2 -1.;

}

parse_data(char *line,int *i1, float *x, float *y)
{
char fmt[20],part[50];
char *temp,*tline,*dptr;
int i,ncol,k;

      if(use_delim == 0)
      {
        ncol = chk_size(line);
        if((ncol < xcol)||(ncol < ycol))
                return(-1);  /* error line not long enough */

        if(vlen > 0 )
        {
                sprintf(fmt,"%%%1ic",vlen);
                sscanf(line,fmt,part);
                part[vlen]='\0';
                sscanf(part,"%i",i1);
        }
        else
        {
                *i1=1;
        }

        temp=&line[vlen+(xcol-1)*dlen];

        if(dlen > 9 )
        {
                sprintf(fmt,"%%%2ic",dlen);
        }
        else
        {
                sprintf(fmt,"%%%1ic",dlen);
        }

        sscanf(temp,fmt,part);
        sscanf(part,"%g",x);

        temp=&line[vlen+(ycol-1)*dlen];

        sscanf(temp,fmt,part);
        sscanf(part,"%g",y);

        return(0); /* every thing ok */
      }
      else
      {
          *i1 = 1;/* invec not used with delimited data */
          tline=line; /* get line start */
strip2:
          if(tline[strlen(tline)-1] == delim_char) /* remove trailing delims */
          {
              tline[strlen(tline)-1] = '\0';
              goto strip2;
          }

          i = 1; /* current data column */
          k = 0; /* number of values found: (x,y) == 2 */
more:
          dptr = strchr(tline,delim_char); /* find next delimiter */

          if((dptr == NULL)&&!((k == 1)&&((xcol == i)||(ycol == i))))
          {
                return (-1); /* error */
          }

          if(dptr != NULL)
          {
               *dptr = '\0';  /* make delimiter eos */
          }

          strncpy(part,tline,50);  /* pull off column up to delimiter */

          if(dptr != NULL)
          {
                tline = dptr + 1; /* move along the line */
strip:
                if(tline[0] == ' ')  /* remove extra blanks from front */
                {
                        tline = tline+1;
                        goto strip;
                }

          }

          if(xcol == i)
          {
               *x=atof(part);
               k++;
          }
          if(ycol == i)
          {
               *y=atof(part);
               k++;
          }

          i++; /* ready for next column */

          if(k < 2) goto more;/* if we haven't got all our data yet */

          return(0); /* every thing ok */

      }

}


int chk_size(char *line)
{
int ncol,l;
char *dptr,*tline;
        if(use_delim == 0)
        {
             l=strlen(line);
             ncol = (int) ((l-vlen)/((float)dlen)+.5);
        }
        else
        {
             ncol = 1;
             tline=line;
strip2:
            if(tline[strlen(tline)-1] == delim_char ) /* remove trailing delims */
            {
                tline[strlen(tline)-1] = '\0';
                goto strip2;
            }
more:
             dptr=strchr(tline,delim_char);
             if(dptr != NULL)
             {
                ncol++;
                tline=dptr+1;
strip:
                if(tline[0] == ' ')
                {
                        tline = tline +1;
                        goto strip;
                }
                goto more;
             }

        }

        return ncol;
}

int get_cols(char *line,int x,int y)
{
int i,ncol,xc,yc;

        ncol=chk_size(line);

        if(ncol == 2)
        {
                xcol = 1;
                ycol = 2;
                return (1) ;
        }
        if(ncol < 2)
        {
                info_window(x,y,"Data format error");
                return (0);
        }

        if(ncol >= MAXCOLUMNS)
        {
                info_window(x,y,"Too many columns in file");
                return(0);
        }

        xc =1;
        yc=2;

        cols_form(&xc,&yc,ncol,x,y);
        xcol = xc;
        ycol = yc;

        return (1);

}

int auto_np(char *line)
{
char *tline;

        if(use_delim == 0)
        {
            if (strlen(line) < dlen )  /* check for np */
            {
                 sscanf(line,"%i", &np);
                 use_eof = 0;
            }
            else
            {
                  np=npmax;
                  use_eof = 1;
            }
        }
        else
        {
            tline=line;
strip:
            if(tline[0] == ' ') /* remove leading blanks */
            {
                tline = tline + 1;
                goto strip;
            }
strip2:
            if(tline[strlen(tline)-1] == delim_char) /* remove trailing delims */
            {
                tline[strlen(tline)-1] = '\0';
                goto strip2;
            }

            if(strchr(tline,delim_char)==NULL)
            {
                 sscanf(tline,"%i", &np);
                 use_eof = 0;
            }
            else
            {
                 np=npmax;
                 use_eof = 1;
            }
        }
}

read_gf(char *name,int xpos,int ypos)
{
FILE *gffile;
int i,i1,len,tvlen,nline,tuse_delim;
float x,y;
char line[251];
char temp[100];
char fmt[20],fmt2[20];

/*
      modifed for X version, for File form


*/

len = 250;
nline = 0;

tryagain:
        if((gffile=fopen(name,"r")) == NULL )
        {
                if(strstr(lowercase(name),".gf") == NULL)
                {
                        strcat(name,".gf");
                        goto tryagain;
                }
                else
                {
                        info_window(xpos,ypos,"File not found");
                        return(-1);
                }
        }

/* skip the comment lines -- not transfered on save */

	do{
        	fgets(line,len,gffile);
        	nline++;
        }
        while( (line[0] == 'c') || (line[0] == 'C') );

/* old check for np

        if (strlen(line) < dlen )
        {
             sscanf(line,"%i", &np);
             use_eof = 0;
        }
        else
        {
                np=npmax;
                use_eof = 1;
        }
*/
        auto_np(line);

        if(np > npmax )
        {
                info_window(xpos,ypos,"Too many points");
                fclose(gffile);
                return(-1);
        }

        if(use_eof == 0)
        {
               fgets(line,len,gffile);
               nline++;
        }

        if(get_cols(line,xpos,ypos) == 0)
        {
                fclose(gffile);
                return(-1);
        }

        strcpy(filecurrent,name);    /* change the current file name */

        if(parse_data(line,&i1,&x,&y) == -1 )
        {
                sprintf(temp,"Error on data parsing in line %i",nline);
                info_window(xpos,ypos,temp);
                fclose(gffile);
                np=0;
                return(-1);
        }

        iv[1]=i1;
        xp[1]=x;
        yp[1]=y;

        for(i=2;i<=np;i++)
        {

/*      fscanf(gffile,"%3i%10f%10f",&i1,&x,&y);  */

             fgets(line,len,gffile);
             nline++;
/*
             if(use_eof == 1)
             {
                     if( feof(gffile))
                     {
                             np=i-1;
                             goto at_eof;
                     }
             }
*/
              if(use_eof == 1)
              {
                      if( feof(gffile))
                      {
                      	      if(parse_data(line,&i1,&x,&y) != -1 )
                      	      {
                      	      	iv[i]=i1;
                      	      	xp[i]=x;
                      	      	yp[i]=y;
                      	      	np=i;
                      	      	goto at_eof;
                      	      }
                      	      
                              np=i-1;
                              goto at_eof;
                      }
              }

             if(parse_data(line,&i1,&x,&y) == -1 )
             {
                     sprintf(temp,"Error on data parsing in line %i",nline);
                     info_window(xpos,ypos,temp);
                     fclose(gffile);
                     np = 0;
                     return(-1);
             }

             iv[i]=i1;
             xp[i]=x;
             yp[i]=y;
        }

        if(use_eof == 1)
        {
                sprintf(temp,"Too many points, file truncated");
                info_window(xpos,ypos,temp);
        }

at_eof:
        sprintf(fmt,"%%%ig%%%ig",dlen,dlen);

 /* should work like this for any read below failing */

        if(fgets(line,len,gffile)==NULL || feof(gffile) || use_eof==1 )
        {
                fclose(gffile);
                
                /* should ask it want to keep comments/scaling from 
                   previous setup here */
                if(num_comments != 0)
                {
                	if(yes_no_window(xpos,ypos,"Keep previous comments?",NO) == NO)
                		num_comments=0;
                }
                rescale(1);
        }
        else
        {

        /* dummys for parsing of scaling */
                tvlen=vlen;
                vlen=0;
                tuse_delim=use_delim;
                use_delim=0;


                xcol=1;
                ycol=2;

                parse_data(line,&i1,&x,&y);

                xmax=y;
                xmin=x;

                s1=0;

                if(strlen(line) > 2*dlen+1)
                {
                        if(line[strlen(line)-2] == 'L') s1=1;
                }
                else
                {
                        s1=0;
                }

                fgets(line,len,gffile);

                parse_data(line,&i1,&x,&y);

                ymax=y;
                ymin=x;

                s2=0;

                if(strlen(line) > 2*dlen+1)
                {
                        if(line[strlen(line)-2] == 'L') s2=1;
                }
                else
                {
                        s2=0;
                }

                fgets(xlabel,len,gffile);
                strip_crlf(xlabel);
                
                fgets(ylabel,len,gffile);
                strip_crlf(ylabel);

                strcpy(fmt2,"%c");
                strcat(fmt2,fmt);

                fscanf(gffile,fmt2,&ticks,&x,&y);

                ytick=y;
                xtick=x;

                /* restore changed variables */
                vlen=tvlen;
                use_delim=tuse_delim;

                num_comments = 0;

               fgets(line,len,gffile);

               if(!feof(gffile))
               {
more_comments:
                fgets(line,len,gffile);

                if(line[0]==10 && !feof(gffile)) goto more_comments;
                if(line[0]=='\0' && !feof(gffile)) goto more_comments;
                if(strlen(line) == 0 && !feof(gffile)) goto more_comments;

                if(!feof(gffile))
                {
                	strip_crlf(line);
                        strcpy(comments[num_comments],line);
                        fscanf(gffile,"%i   %i",&com_row[num_comments],&com_col[num_comments]);
                        num_comments++;
                        goto more_comments;
                 }
                }

                fclose(gffile);


        }

	if(debug)
	{
        	printf("File read in with %i points \n",np);

       		printf(" xmax = %f   xmin = %f  ",xmax,xmin);
        	if(s1 == 1) printf("  (log scale) \n");
        	if(s1 == 0) printf("  (linear scale) \n");
        	printf(" ymax = %f   ymin = %f  ",ymax,ymin);
        	if(s2 == 1) printf("  (log scale) \n");
        	if(s2 == 0) printf("  (linear scale) \n");
       		printf(" x label = %s \n",xlabel);
        	printf(" y label = %s \n",ylabel);
        	printf("ticks = %c  x ticks = %f, y ticks = %f \n",ticks,xtick,ytick);
	}
}

void strip_crlf(char *text)
{
/*  
	strips any trailing \r or \n  from text 
*/
int len;
	len = strlen(text);
	
	if(len < 1) return; /* empty string */
	
	len=len-1;
	
	while(text[len] == '\r' || text[len] == '\n')
	{
		text[len]='\0'; /* null it out */
		len--;
		if(len < 0) return;
	}
}


int x_coord(float x)
{

int xc;
/*
xc = (int)(xl+(xr-xl)*(x-xmin)/(xmax-xmin));
*/
    if( s1 == 0)
    {
           xc=(int)((x - xmin) / (xmax - xmin) * ((float)xr - (float)xl) + (float)xl + .5);
    }
    else
    {
           xc=((int) ((log(x) - log(xmin)) / (log(xmax) - log(xmin)) * ((float)xr - (float)xl) + (float)xl + .5));
    }

return xc;

}

int y_coord(float y)
{

int yc;
/*
yc = (int)((float)yu+((int)yb-(int)yu)*(ymax-y)/(ymax-ymin));
*/

/* changed for ps/hpgl compatibility */

    if( s2 == 0)
    {
    /*    was
          yc=((int)((ymax - y)/ (ymax - ymin) * ((int)yb - (int)yu) + yu + .5) );
    */
          yc=((int)((y - ymin)/ (ymax - ymin) * ((float)yu - (float)yb) + (float)yb + .5) );
    }
    else
    {
    /*   was
          yc=((int)((log(ymax) - log(y)) / (log(ymax) - log(ymin)) * (yb - yu) + yu + .5));
    */
          yc=((int)((log(y) - log(ymin)) / (log(ymax) - log(ymin)) * ((float)yu - (float)yb) + (float)yb + .5));
    }

return yc;

}



wind (int *x0,int *y0,int  *x ,int  *y,int  *os)
{
/*
1685 REM
1690 REM   CALL THIS WITH (X0,Y0)-(X,Y) TO GET LINE WINDOWED
1695 REM
*/
int u0,v0,u,v,f,xn,yn;

/*   if we use clip box  --- but lets check it works first...
if(device ==  1){ *os = 0; return(0); }
*/

     *os = 0; u0 = *x;  v0 = *y;  u = *x0;  v = *y0;

     endpoint(u0,v0,u,v,&f,&xn,&yn);

     if( f != 0)         /*   THEN 1750  */
     {
        if(xn > (int)xr || xn < (int)xl || yn < (int)yb || yn > (int)yu) *os = 1;
        if(abs(u0 - u) < (abs(u0 - xn) + abs(u - xn))) *os = 1;
        if(abs(v0 - v) < (abs(v0 - yn) + abs(v - yn))) *os = 1;
        if(*os == 1) return(-1); /*               WHOLE LINE OFF SCREEN  */
     }

     u0 = xn; v0 = yn;  u = *x;  v = *y;
     endpoint(u0,v0,u,v,&f,&xn,&yn);

     if(f != 0 ) *os = -1;
     *x0 = u0; *y0 = v0;  *x = xn;  *y = yn;

}


endpoint(int u0,int v0,int u,int v,int *f,int *xn,int *yn)
{
float m,b;
int sf,t;
/*
1585 REM
1590 REM   CALLED BY wind TO DO EACH END POINT OF A LINE
1595 REM
*/
     *f = 0;

     if( u > (int)xr) { *f = 1;  *xn = xr; }

     if( u < (int)xl) { *f = 1; *xn = xl;}

     if( v > (int)yu) { *f = *f - 2; *yn = yu;}

     if( v < (int)yb) { *f = *f - 2; *yn = yb;}

     if( *f == 0 ) { *xn = u; *yn = v;  return(0);}

     if(abs(u - u0) > abs(v - v0) )
     {
/* find y = m x + b */
                m = ((float)(v - v0)) /((float) (u - u0));
                b = (float)v - m * (float)u;
                sf = 1 ;
     }
     else
     {
/* find x = m y + b */
                 m = ((float)(u - u0)) / ((float)(v - v0));
                b = (float)u - m * (float)v;
                sf = 0;
     }

     if(*f == 1 && sf == 1 ) { *yn = (int)(m *(float) (*xn) + b); return(0);}

     if(*f == 1 && sf == 0 && m != 0 ) { *yn = (int)(((float)*xn - b) / m); return(0);}

     if(*f == -2 && sf == 1 && m != 0 ) { *xn = (int)(((float)*yn - b) / m); return(0);}

     if(*f == -2 && sf == 0 ) { *xn = (int)(m * (float)(*yn) + b); return(0);}

     if( sf == 1 )
     {
          t = *yn; *yn = (int)(m * (float)(*xn) + b);

          if( (*yn > (int)yu || *yn < (int)yb) && m != 0 )
          {
             *xn = (int)(((float)t - b) / m);  *yn = t;
          }
     }

     if( sf == 0 )
     {
          t = *xn; *xn = (int)(m * (*yn) + b);

          if( (*xn > (int)xr || *xn < (int)xl) && m != 0 )
          {
               *yn = (int)(((float)t - b) / m);  *xn = t;
          }
     }
}

int chkpt (int i)
{
/*
REM
REM             CHECK POINT ON SCREEN
REM
*/
float x,y;
int xt,yt;
int os;

       x = xp[i];  y = yp[i];

       xt=x_coord(x);
       yt=y_coord(y);

       os=0;
       if( xt < (int)xl || xt > (int)xr) os=1;
       if( yt < (int)yb || yt > (int)yu) os=1;

       return(os);

}

symbol (int x,int y,int t1)
{
/*
12010 ON dv GOTO 12205, 13050, 14050' SYMBOL
4897 REM
4898 REM  SCREEN/PEN PLOTTER SYMBOLS
4899 REM
*/
int d,t;

/*   use procs in PostScript  */

if(device ==  3) {ps_symbol(x, y, t1); return(0);  }


d = vp*((float)xr - (float)xl) / 50; /* size of the symbols scale with the text */

if(device == 1 && d < 8 ) d=8;

if( device ==  2){  t = 0; ulinetype(&t);}

if( t1 < 5)
{
        draw_symbol(x,y,t1,d);
}
else
{                  /* solid symbols */
     t = d;
     for(d = t;d >= t / 5;d=d-t / 5)
     {
        draw_symbol(x,y,t1,d);
     }
}

t = linetype; ulinetype(&t);

}

draw_arrow(int x, int y,int i,int fill)
{
float a,r,x0,y0,x1,y1,theta,a1,r1;
int t,dx,dy;

        a = 25.*3.14159/180.;  /* angle of the arrow head */

        x0 = xp[i-1];y0=yp[i-1];

        xy[1] = x_coord(x0);
        xy[2] = y_coord(y0);

        dx = x - xy[1];
        dy = y - xy[2];

        xy[3] = x; xy[4] = y;
        t=2;dline(t);

        if(arrow_size == 0.)
        {
                r = .2* vp * sqrt( dx*dx + dy*dy);
        }
        else
        {
                r = arrow_size*((float)xr-(float)xl)/30.;
        }

        if( r < 1 ) r = 1;

        theta = 3.14159/2.;
        if (dy < 0) theta = - theta;
        if (dx != 0.) theta = atan(((float)dy)/((float)dx));

        if(dx < 0 ) theta = theta + 3.14159;

        x0 = (int)(x - r *cos(a + theta));
        y0 = (int)(y - r* sin(a + theta));

        xy[1]=x0;
        xy[2]=y0;
        xy[3]=x;
        xy[4]=y;
        t = 4;

        x1 = (int)(x - r*cos(-a+theta));
        y1 = (int)(y - r*sin(-a+theta));

        xy[5]=x1;xy[6]=y1;
        xy[7]=x0;xy[8]=y0;
        dline(t);

        if(fill != 0)
        {

/* filled arrow */


        for(a1 = a-a/r/2.; a1>0;a1=a1-a/r/2.)
        {
                r1 = a1/a * r;
                x0 = (int)(x - r1 *cos(a1 + theta));
                y0 = (int)(y - r1* sin(a1 + theta));

                xy[1]=x0;
                xy[2]=y0;
                xy[3]=x;
                xy[4]=y;
                t = 2;
                dline(t);

                xy[1]=x;xy[2]=y;t=3;

                x1 = (int)(x - r1*cos(-a1+theta));
                y1 = (int)(y - r1*sin(-a1+theta));

                xy[3]=x1;xy[4]=y1;
                xy[5]=x0;xy[6]=y0;
                dline(t);
        }

        }

}


draw_symbol(int x,int y,int t1,int d)
{
int dd,t,ii;
float pi=3.14159;

if (t1 == 1 || t1 == 5)
{
/* square   */
dd = d / 2; xy[1] = x - dd;  xy[2] = y - dd;  xy[3] = x + dd;  xy[4] = y - dd;  xy[5] = x + dd;  xy[6] = y + dd;
xy[7] = x - dd; xy[8] = y + dd;  xy[9] = x - dd;  xy[10] = y - dd;  t = 5;   dline( t);
}
if (t1 == 2 || t1 == 6)
{
/*    circle  */
for( ii = 1;ii<=25;ii++){ xy[2 * ii - 1] =(int)( x + d * cos(2. * pi * (float)(ii - 1) / 24.) / 2.);  xy[2 * ii] =(int)( y + d * sin(2. * pi * (float)(ii - 1) / 24.) / 2.);}
t = 25;  dline( t);
}
if (t1 == 3 || t1 == 7)
{
/*   triangle  */
xy[1] = x; xy[2] = y - d / 3;  xy[3] = x + (d * 577)/1000;  xy[4] = y - d / 3;  xy[5] = x;  xy[6] = y + (2 * d) / 3;
xy[7] = x - (d *577)/1000; xy[8] = y - d / 3;  xy[9] = x;  xy[10] = y - d / 3;  t = 5;   dline( t);
}
if (t1 == 4 || t1 == 8)
{
/*    cone  */
xy[1] = x; xy[2] = y + d / 3;  xy[3] = x + (d * 577)/1000;  xy[4] = y + d / 3;  xy[5] = x;  xy[6] = y - 2 * d / 3;
xy[7] = x - (d * 577)/1000; xy[8] = y + d / 3;  xy[9] = x;  xy[10] = y + d / 3;  t = 5;   dline( t);
}

if (t1 > 8)
{
/*    cross  */
dd=d/2; xy[1] = x-dd; xy[2] = y - dd;  xy[3] = x + dd ;  xy[4] = y + dd ;
  t = 2;   dline( t);
  xy[1] = x-dd; xy[2] = y + dd;  xy[3] = x + dd ;  xy[4] = y - dd ;
  t = 2;   dline( t);

}
}

void time_and_date(char *dt)
{
/*
	fills the string pointed to by dt with 
	the current date and time
*/	
struct timeval tv;
struct timezone tz;
time_t secs;

	gettimeofday(&tv, &tz);
	
	secs=tv.tv_sec; /* ignore the microseconds */
	
	strcpy(dt,ctime(&secs));
	
	dt[strlen(dt)-1]='\0'; /* remove trailing \n */
	 
}	 
